Attribute VB_Name = "mdlCPUInfo"

'***********************
'* mdlCPUInfo.bas
'***********************
Option Explicit

'//==================================================================
'//     CPU Monitor CODE WinNT START
'//     ORIGINAL CODER: The KPD-Team at http://www.allapi.net
'//==================================================================
Private Const SYSTEM_BASICINFORMATION = 0&
Private Const SYSTEM_PERFORMANCEINFORMATION = 2&
Private Const SYSTEM_TIMEINFORMATION = 3&
Private Const NO_ERROR = 0

'// We use Currency instead of LARGE_INTEGER
'// So we don't have to convert back and forth
'Private Type LARGE_INTEGER
'    dwLow As Long
'    dwHigh As Long
'End Type
'
Private Type SYSTEM_BASIC_INFORMATION
    dwUnknown1 As Long
    uKeMaximumIncrement As Long
    uPageSize As Long
    uMmNumberOfPhysicalPages As Long
    uMmLowestPhysicalPage As Long
    uMmHighestPhysicalPage As Long
    uAllocationGranularity As Long
    pLowestUserAddress As Long
    pMmHighestUserAddress As Long
    uKeActiveProcessors As Long
    bKeNumberProcessors As Byte
    bUnknown2 As Byte
    wUnknown3 As Integer
End Type

Private Type SYSTEM_PERFORMANCE_INFORMATION
    liIdleTime As Currency
    dwSpare(0 To 75) As Long
End Type

Private Type SYSTEM_TIME_INFORMATION
    liKeBootTime As Currency
    liKeSystemTime As Currency
    liExpTimeZoneBias  As Currency
    uCurrentTimeZoneId As Long
    dwReserved As Long
End Type

Public Type OSVERSIONINFO
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
    szCSDVersion As String * 128
End Type

Private Declare Function GetVersionEx Lib "Kernel32" Alias "GetVersionExA" _
                (lpVersionInformation As OSVERSIONINFO) As Long
Private Declare Function NtQuerySystemInformation Lib "ntdll" (ByVal dwInfoType As Long, _
                ByVal lpStructure As Long, ByVal dwSize As Long, _
                ByVal dwReserved As Long) As Long

Private liOldIdleTime       As Currency
Private liOldSystemTime     As Currency
'//==================================================================
'//     CPU Monitor CODE WinNT END
'//==================================================================

'//==================================================================
'//     CPU Monitor CODE Win9X START
'//     ORIGINAL CODER: The KPD-Team at http://www.allapi.net
'//==================================================================
Private Const STANDARD_RIGHTS_ALL = &H1F0000
Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_SET_VALUE = &H2
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_NOTIFY = &H10
Private Const KEY_CREATE_LINK = &H20
Private Const SYNCHRONIZE = &H100000
Private Const READ_CONTROL = &H20000
Private Const STANDARD_RIGHTS_READ = (READ_CONTROL)
Private Const HKEY_DYN_DATA = &H80000006
Private Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))
Private Const KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
Private Const ERROR_SUCCESS = 0&
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Private hKey As Long, dwDataSize As Long, dwCpuUsage As Byte, dwType As Long
'//==================================================================
'//     CPU Monitor CODE Win9X END
'//==================================================================

Private m_IsWinNT As Boolean

'// Return True is the OS is WindowsNT3.5(1), NT4.0, 2000, Me, XP
Public Sub IsWinNTInstalled()
    Dim OSInfo As OSVERSIONINFO
    OSInfo.dwOSVersionInfoSize = Len(OSInfo)
    'retrieve OS version info
    GetVersionEx OSInfo
    'if we're on NT, return True
    m_IsWinNT = (OSInfo.dwPlatformId = 2)
End Sub

'// Setup the nesaccary options to start retreiving CPU Permormance data
Public Sub CPUInitialize()
Dim SysTimeInfo     As SYSTEM_TIME_INFORMATION
Dim SysPerfInfo     As SYSTEM_PERFORMANCE_INFORMATION
Dim ret             As Long
    
    '// Initialize the CPU Load settings based on if user is using Windows NT or 9x
    If m_IsWinNT Then
        '// get new system time
        ret = NtQuerySystemInformation(SYSTEM_TIMEINFORMATION, VarPtr(SysTimeInfo), LenB(SysTimeInfo), 0&)
        If ret <> NO_ERROR Then
            Debug.Print "Error while initializing the system's time!", vbCritical
            Exit Sub
        End If
        
        '// get new CPU's idle time
        ret = NtQuerySystemInformation(SYSTEM_PERFORMANCEINFORMATION, VarPtr(SysPerfInfo), LenB(SysPerfInfo), ByVal 0&)
        If ret <> NO_ERROR Then
            Debug.Print "Error while initializing the CPU's idle time!", vbCritical
            Exit Sub
        End If
        
        '// store new CPU's idle and system time
        liOldIdleTime = SysPerfInfo.liIdleTime
        liOldSystemTime = SysTimeInfo.liKeSystemTime
    Else
        '// start the counter by reading the value of the 'StartStat' key
        If RegOpenKeyEx(HKEY_DYN_DATA, "PerfStats\StartStat", 0, KEY_ALL_ACCESS, hKey) <> ERROR_SUCCESS Then
            Debug.Print "Error while initializing counter"
            Exit Sub
        End If
        dwDataSize = 4 'Length of Long
        RegQueryValueEx hKey, "KERNEL\CPUUsage", ByVal 0&, dwType, dwCpuUsage, dwDataSize
        RegCloseKey hKey
        
        '// get current counter's value
        If RegOpenKeyEx(HKEY_DYN_DATA, "PerfStats\StatData", 0, KEY_READ, hKey) <> ERROR_SUCCESS Then
            Debug.Print "Error while opening counter key"
            Exit Sub
        End If
    
    End If
        
End Sub

'// Return the current CPU Load based on if the user is running Windows 9x or NT
Public Function CPUQuery() As Single
Dim SysBaseInfo     As SYSTEM_BASIC_INFORMATION
Dim SysPerfInfo     As SYSTEM_PERFORMANCE_INFORMATION
Dim SysTimeInfo     As SYSTEM_TIME_INFORMATION
Dim dbIdleTime      As Currency
Dim dbSystemTime    As Currency
Dim ret             As Long
    
    If m_IsWinNT Then
        '// Set Initial Value
        CPUQuery = -1
        
        '// get number of processors in the system
        ret = NtQuerySystemInformation(SYSTEM_BASICINFORMATION, VarPtr(SysBaseInfo), LenB(SysBaseInfo), 0&)
        If ret <> NO_ERROR Then
            Debug.Print "Error while retrieving the number of processors!", vbCritical
            Exit Function
        End If
        
        '// get new system time
        ret = NtQuerySystemInformation(SYSTEM_TIMEINFORMATION, VarPtr(SysTimeInfo), LenB(SysTimeInfo), 0&)
        If ret <> NO_ERROR Then
            Debug.Print "Error while retrieving the system's time!", vbCritical
            Exit Function
        End If
        
        '// get new CPU's idle time
        ret = NtQuerySystemInformation(SYSTEM_PERFORMANCEINFORMATION, VarPtr(SysPerfInfo), LenB(SysPerfInfo), ByVal 0&)
        If ret <> NO_ERROR Then
            Debug.Print "Error while retrieving the CPU's idle time!", vbCritical
            Exit Function
        End If
        
        '// CurrentValue = NewValue - OldValue
        dbIdleTime = (SysPerfInfo.liIdleTime) - (liOldIdleTime)
        dbSystemTime = (SysTimeInfo.liKeSystemTime) - (liOldSystemTime)
        
        '// CurrentCpuIdle = IdleTime / SystemTime
        If dbSystemTime <> 0 Then dbIdleTime = dbIdleTime / dbSystemTime
        
        '// CurrentCpuUsage% = 100 - (CurrentCpuIdle * 100) / NumberOfProcessors
        dbIdleTime = 100 - dbIdleTime * 100 / SysBaseInfo.bKeNumberProcessors + 0.5
        
        '// Return Query Value
        CPUQuery = CLng(dbIdleTime)
        
        '// store new CPU's idle and system time
        liOldIdleTime = SysPerfInfo.liIdleTime
        liOldSystemTime = SysTimeInfo.liKeSystemTime
    Else
    
        '// Size of Long
        dwDataSize = 4
        
        '// Query the counter in the Registry
        If RegQueryValueEx(hKey, "KERNEL\CPUUsage", ByVal 0&, dwType, dwCpuUsage, dwDataSize) = NO_ERROR Then
            '// Return Value
            CPUQuery = CLng(dwCpuUsage)
        Else
            MsgBox "Unable to Query Registry!"
            CPUQuery = -1
        End If
    End If
    
End Function

'// Stop the CPU Query
Public Sub CPUTerminate()

    '// We only need to do this if NOT WindowsNT.
    '// For WindowsNT based systems there is nothing we need to do
    If Not m_IsWinNT Then
        '// Close the Registry
        RegCloseKey hKey
        '// Stop the counter
        If RegOpenKeyEx(HKEY_DYN_DATA, "PerfStats\StopStat", 0, KEY_ALL_ACCESS, hKey) <> ERROR_SUCCESS Then
            Debug.Print "Error while stopping counter"
            Exit Sub
        End If
        dwDataSize = 4 'length of Long
        RegQueryValueEx hKey, "KERNEL\CPUUsage", ByVal 0&, dwType, dwCpuUsage, dwDataSize
        RegCloseKey hKey
    End If
    
End Sub

