Attribute VB_Name = "mdlGeneral"

'***********************
'* mdlGeneral.bas
'***********************
Option Explicit

Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, _
                ByVal lpWindowName As String) As Long
Private Declare Function GetDesktopWindow Lib "user32" () As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, _
                ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, _
                ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, _
                ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SetLayeredWindowAttributes Lib "user32" (ByVal hwnd As Long, ByVal crKey As Long, _
                ByVal bAlpha As Byte, ByVal dwFlags As Long) As Long
Private Declare Function Shell_NotifyIcon Lib "shell32" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, _
                lpData As NOTIFYICONDATA) As Long

Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Private Type NOTIFYICONDATA
        cbSize As Long
        hwnd As Long
        uID As Long
        uFlags As Long
        uCallbackMessage As Long
        hIcon As Long
        szTip As String * 64
End Type

Private Const HWND_TOPMOST = -1
Private Const SWP_NOSIZE = &H1
Private Const GWL_EXSTYLE = (-20)
Private Const WS_EX_LAYERED = &H80000
Private Const LWA_ALPHA = &H3
Private Const LWA_COLORKEY = &H1
Private Const NIF_ICON = &H2
Private Const NIF_MESSAGE = &H1
Private Const NIF_TIP = &H4
Private Const NIM_DELETE = &H2
Private Const NIM_ADD = &H0
Private Const WM_MOUSEMOVE = &H200

Rem  
Public Sub SetWindowPosition(ByRef FormObj As Form)

Dim ScreenWidth As Integer
Dim ScreenHeight As Integer
Dim TaskBarRect As RECT

'  
ScreenWidth = Screen.Width / Screen.TwipsPerPixelX
'  
ScreenHeight = Screen.Height / Screen.TwipsPerPixelY
'  Rect TrayBar'   
'   TrayBar
GetWindowRect FindWindow("Shell_traywnd", vbNullString), TaskBarRect
ScreenHeight = ScreenHeight - (TaskBarRect.Bottom - TaskBarRect.Top)

'       TrayBar'
SetWindowPos FormObj.hwnd, HWND_TOPMOST, ScreenWidth - (FormObj.Width / Screen.TwipsPerPixelX), _
             ScreenHeight - (FormObj.Height / Screen.TwipsPerPixelY), 0, 0, SWP_NOSIZE

End Sub 'SetWindowPosition

Rem   
Rem Lays-   0  255
Public Sub SetWindowTransparencity(ByVal hWindow As Long, Lays As Byte)

Dim WndStyle As Long

WndStyle = GetWindowLong(hWindow, GWL_EXSTYLE)
'    
WndStyle = WndStyle Or WS_EX_LAYERED
SetWindowLong hWindow, GWL_EXSTYLE, WndStyle
SetLayeredWindowAttributes hWindow, LWA_COLORKEY, Lays, LWA_ALPHA

End Sub 'SetWindowTransparencity

Rem    Tray
Public Sub SetTrayIcon(ByVal PicParentObj As Form)

Dim SetTI As NOTIFYICONDATA

With SetTI
    .cbSize = Len(SetTI)
    .hwnd = PicParentObj.picMsgHook.hwnd
    .uID = 1&
    .uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
    .uCallbackMessage = WM_MOUSEMOVE
    .hIcon = PicParentObj.Icon
    .szTip = " " + Chr$(0)
End With

Shell_NotifyIcon NIM_ADD, SetTI

End Sub 'SetTrayIcon

Rem    Tray'
Public Sub KillTrayIcon(ByVal PicParentObj As Form)

Dim KillTI As NOTIFYICONDATA

With KillTI
    .cbSize = Len(KillTI)
    .hwnd = PicParentObj.picMsgHook.hwnd
    .uID = 1&
End With

Shell_NotifyIcon NIM_DELETE, KillTI

End Sub 'KillTrayIcon
